#!/usr/bin/python
# -*- coding: UTF-8 -*-

## trans.py - Contains the transliteration script for English to Indic Scripts
## Copyright (C) 2009 Red Hat, Inc.
## Copyright (C) 2009 Pravin Satpute <psatpute@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# mapping from half font characters to Unicode
half = {
	  96:"क्ष", 143:"ख", 144:"ग", 157:"ण", 158:"ल", 161:"त्र", 162:"त्त", 163:"थ", 172:"ध", 173:"न", 174:"न्न", 175:"प", 176:"फ", 178:"ब", 179:"भ", 180:"म",181:"य",187:"ल",190:"व",191:"श",0xc1:"श्र",193:"ष",195:"स",196:"स्र",197:"ह",245:"ख्र",246:"झ्र",376:"त" ,8226:"ज", 129:"ल",8216:"घ",8220:"च",8211:"ज्ञ",8212:"झ",732:"ञ",338:"क",65437:"ण",65424:"ग",194:"ष" }

# mapping from full font characters to Unicode, dont need any extra processing
full = {
141:"क", 164:"द", 165:"दृ",166:"द्र", 167:"द्द",168:"ध्द",169:"द्म",170:"द्य",171:"द्व",177:"फ", 183:"ऱ्", 182:"्य", 184:"र", 185:"रु", 186:"रू", 188:"ट्ट", 189:"ट्ठ" ,198:"ह",199:"हृ",200:"ह्र",201:"ह्म",202:"ह्य", 203:"्",204:"़",205:"़",206:"्र",207:"्र",208:"्र",209:"ँ", 210:"्र",211:"ं",214:"ा", 223:"ी", 224:"ीं", 227:"ु",228:"्रु", 229:"ु",230:"ू",231:"्रू",232:"ू",233:"ृ",234:"े", 235:"ें",238:"ै",239:"ैं", 242:"ॅ",243:"ळ्", 244:"ळ",  247:"ठ्ठ", 248:"ड्ड",  249:"ड्ढ",339:"ढ",352:"ॠ",353:"ठ",408:"ऽ",8224:"अ",8482:"ट",8217:"ङ",8218:"ॐ",8220:"छ",8220:"ः",8225:"इ",8230:"।",8240:"ऊ",8249:"ए",8250:"ड",710:"उ",65421:"क"
}

#used for splitting reph conjucts of fonts, for simplicity in processing
matras = { 215:"ि",216:"िं",217:"Ôि" ,218:"Ôिं",219:"ि",220:"िं",221:"Ôि" ,222:"Ôिं", 225:"Ôी" , 226:"Ôी", 236:"Ôे",237:"Ôें",240:"Ôै",241:"Ôैं",213:"Ôं"}

#used for reordering of reph
matra = ["ा","ि","ी","ु","ू","ृ","ॄ","ॅ","ॆ","े","ै","ॉ","ॊ","ो","ौ"]

cons = ["क","ख","ग","घ","ङ","च","छ","ज","झ","ञ","ट","ठ","ड","ढ","ण","त","थ","द","ध","न","ऩ","प","फ","ब","भ","म","य","र","ऱ","ल","ळ","ऴ","व","श","ष","स","ह"]





