#!/usr/bin/python
# -*- coding: UTF-8 -*-

## trans.py - Contains the transliteration script for English to Indic Scripts
## Copyright (C) 2009 Red Hat, Inc.
## Copyright (C) 2009 Pravin Satpute <psatpute@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import os, sys
from ddict import *
import reorder_chars

def map_to_unicode(filename):
	buf = file(filename).read()
	buf = unicode(buf, "utf8")
	buf = buf.strip()
	buffer = ""
	i = 0
	while i < len(buf):
		if half.has_key(ord(buf[i])):
			if full.has_key(ord(buf[i+1])) :
				if ord(buf[i+1]) ==214:
					buffer += half[ord(buf[i])]
					i = i+1
				else:
					buffer += half[ord(buf[i])]
					buffer +="्"
			else:
				buffer += half[ord(buf[i])]
				buffer +="्"
		else:
			if full.has_key(ord(buf[i])):
				if ord(buf[i]) == 8224 and (ord(buf[i+1]) == 214 or ord(buf[i+1]) == 242 ): 
					if ord(buf[i+2]) == 234 or ord(buf[i+2]) == 238 or ord(buf[i+2]) == 242:
						if ord(buf[i+2]) == 234:
							buffer += "ओ"
						if ord(buf[i+2]) == 238:
							buffer += "औ"
						if ord(buf[i+2]) == 242:
							buffer += "ऑ"
						i = i +2
					else:
						if ord(buf[i+1]) == 242 :
							buffer += "ॲ"
							i = i+1
						else:
							buffer += "आ"
							i = i+1
				else:
					buffer += full[ord(buf[i])]
			else:
				if ord(buf[i])>=250 and ord(buf[i]) <=254:
					no_need = 0
				else:
					buffer += buf[i].encode("UTF-8")
		i = i +1
	buffer=	process_buffer(buffer)
	return buffer


# spliitted joined matras so in next phase it will be easy to reorder only required part of matra
def process_buffer(buff):
	buf = buff.decode("UTF-8")
	i = 0
	buffer = ""
	while i < len(buf):
		if ord(buf[i])>=215 and ord(buf[i])<=222:
			j = i+1
			flag = 0
			while  j < len(buf):
				if ord(buf[j])==2381:
					flag = 0
					buffer +=buf[j]
				else:
					flag = flag +1
					if flag ==2:	
						break
					else:
						buffer +=buf[j]						
				j = j +1
			buffer+=buf[i]
			i = j
		else:
			buffer+=buf[i]
			i = i+1	
	buffer= reorder_chars.handle_i_and_reph(buffer)
	return buffer



