#!/usr/bin/python
# -*- coding: UTF-8 -*-

## trans.py - Contains the transliteration script for English to Indic Scripts
## Copyright (C) 2009 Red Hat, Inc.
## Copyright (C) 2009 Pravin Satpute <psatpute@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import os, sys
from ddict import *

def handle_i_and_reph(buff):
	buffer = ""
	i = 0
	while i < len(buff):
			if matras.has_key(ord(buff[i])):
				matra = matras[ord(buff[i])]
				buffer += matra.decode("UTF-8")
			else:
				if ord(buff[i])==2311 and ord(buff[i+1])==212:
					buffer +="ई".decode("UTF-8")
					i = i+1
				else:
					if ord(buff[i])==2366 and i<len(buff)-1:
						if ord(buff[i+1])==2373:
							buffer +="ॉ".decode("UTF-8")
							i = i+1
						else:
							if ord(buff[i+1])==2375:
								buffer +="ो".decode("UTF-8")
								i = i+1
							else:
								if ord(buff[i+1])==2376:
									buffer +="ौ".decode("UTF-8")
									i = i+1
								else:
									if ord(buff[i+1])==2374:
										buffer +="ॊ".decode("UTF-8")
										i = i+1
									else:
										buffer +=buff[i]
					else:
							buffer +=buff[i]
					
			i = i+1
	buffer = reorder_reph(buffer)	
	return buffer


def reorder_reph(buff):
	i = 0
	buffer = ""
	offset = 0
	while i < len(buff):
		if ord(buff[i])==212:
			j = (i-1) + offset
# temp is used for copying string till not getting expected reph position
			temp = ""
			flag = 0
			while j >=0:
				if (ord( buffer[j])==2381) :
					flag = 0
					temp +=buffer[j]
					buffer = buffer[0:len(buffer)-1]
				else:
					if (buffer[j].encode("UTF-8") in matra) and flag ==0:
						temp +=buffer[j]
						buffer = buffer[0:len(buffer)-1]
					else:
						flag = flag +1
						if flag ==2:
							buffer +="र्".decode("UTF-8")
							offset = offset +1
							i = i +1
							k = len(temp)
							while k > 0:
								 buffer +=temp[k-1]
								 k = k -1
							break
						else:
							temp +=buffer[j]
							buffer = buffer[0:len(buffer)-1]
					
				j = j -1
		else:
			buffer +=buff[i]
			i = i+1
	return buffer
